<ui:composition xmlns:s="http://jboss.org/schema/seam/taglib" xmlns:gdk="http://www.ihe.net/gazellecdk"
                xmlns:h="http://java.sun.com/jsf/html" xmlns:rich="http://richfaces.org/rich"
                xmlns:f="http://java.sun.com/jsf/core" xmlns:a4j="http://richfaces.org/a4j"
                xmlns:ui="http://java.sun.com/jsf/facelets" xmlns:g="http://www.ihe.net/gazelle"
                xmlns="http://www.w3.org/1999/xhtml">
    <h:form id="createForm">

        <s:div styleClass="gzl-alert gzl-alert-orange" rendered="#{simulatorBean.hasConnections()}">
            <span class="fa fa-exclamation-triangle"></span>
            <h:outputText value="#{messages['net.ihe.gazelle.atna.SimulatorsHavingAtLeastOneRecordedTLSConnectionC']}"/>
        </s:div>

        <ui:decorate template="/layout/panels/_panel_title.xhtml">
            <ui:define name="panel_title">#{messages['net.ihe.gazelle.atna.SimulatorIdentity']}</ui:define>

            <div class="form-horizontal">

                <s:decorate template="/layout/form/_form_field_horizontal_3-9.xhtml">
                    <ui:param name="id" value="keywordInput"/>
                    <ui:define name="label">#{messages['net.ihe.gazelle.atna.Keyword']}</ui:define>
                    <h:inputText id="keywordInput" value="#{simulatorBean.keyword}"
                                 required="true" styleClass="form-control"/>
                </s:decorate>

                <s:decorate template="/layout/form/_form_field_horizontal_3-9.xhtml">
                    <ui:param name="id" value="certScopeInput"/>
                    <ui:define name="label">#{messages['net.ihe.gazelle.atna.CertificateScope']}</ui:define>
                    <h:selectOneRadio id="certScopeInput" value="#{simulatorBean.certificateScope}" disabled="#{simulatorBean.hasConnections()}">
                        <f:selectItems value="#{simulatorBean.getCertificateScopes()}"/>
                        <a4j:ajax event="change" render="certificateInputDiv"/>
                    </h:selectOneRadio>
                </s:decorate>

                <s:div id="certificateInputDiv">

                    <ui:insert name="simulatorCertificateSelector"/>

                </s:div>

            </div>

        </ui:decorate>
        <ui:decorate template="/layout/panels/_panel_title.xhtml">
            <ui:define name="panel_title">#{messages['net.ihe.gazelle.atna.PeerAuthentication']}</ui:define>

            <div class="form-horizontal">

                <ui:insert name="peerAuthPriorParam"/>

                <s:div id="peerAuthenticationParam">
                    <h:panelGroup rendered="#{simulatorBean.isPeerAuthenticationRequired()}">

                        <s:decorate template="/layout/form/_form_checkbox_horizontal_3-9.xhtml">
                            <ui:define name="label">#{messages['net.ihe.gazelle.atna.UseSystemJavaCacertsTruststore']}</ui:define>
                            <h:selectBooleanCheckbox value="#{simulatorBean.useCACerts}" disabled="#{simulatorBean.hasConnections()}">
                                <a4j:ajax event="change" render="issuersPickList"/>
                            </h:selectBooleanCheckbox>
                        </s:decorate>

                        <s:div id="issuersPickList">
                            <h:panelGroup rendered="#{not simulatorBean.useCACerts}">
                                <s:decorate template="/layout/form/_form_field_horizontal_3-9.xhtml">
                                    <ui:param name="id" value="issuersInput"/>
                                    <ui:define name="label">#{messages['net.ihe.gazelle.atna.TrustedIssuers']}</ui:define>
                                    <rich:pickList id="issuersInput" value="#{simulatorBean.issuers}"
                                                   converter="org.jboss.seam.ui.EntityConverter"
                                                   minListHeight="120px" maxListHeight="200px"
                                                   required="true" disabled="#{simulatorBean.hasConnections()}">
                                        <f:selectItems value="#{simulatorBean.getAvailableIssuers()}"/>
                                    </rich:pickList>
                                </s:decorate>
                            </h:panelGroup>
                        </s:div>

                        <s:decorate template="/layout/form/_form_field_horizontal_3-9.xhtml">
                            <ui:param name="id" value="validatorInput"/>
                            <ui:define name="label">#{messages['net.ihe.gazelle.atna.CertificateValidator']}</ui:define>
                            <h:selectOneMenu id="validatorInput" value="#{simulatorBean.certificateValidator}"
                                             styleClass="form-control gzl-select-text" disabled="#{simulatorBean.hasConnections()}">
                                <f:selectItems value="#{simulatorBean.getCertificateValidators()}"/>
                            </h:selectOneMenu>
                        </s:decorate>

                        <s:decorate template="/layout/form/_form_checkbox_horizontal_3-9.xhtml">
                            <ui:define name="label">#{messages['net.ihe.gazelle.atna.CheckRevocation']}</ui:define>
                            <h:selectBooleanCheckbox value="#{simulatorBean.checkRevocation}" disabled="#{simulatorBean.hasConnections()}"/>
                        </s:decorate>

                    </h:panelGroup>
                </s:div>

            </div>

        </ui:decorate>
        <ui:decorate template="/layout/panels/_panel_title.xhtml">
            <ui:define name="panel_title">#{messages['net.ihe.gazelle.atna.SecurityParameters']}</ui:define>

            <div class="form-horizontal">

                <s:decorate template="/layout/form/_form_field_horizontal_3-9.xhtml">
                    <ui:param name="id" value="protocolsInput"/>
                    <ui:define name="label">#{messages['net.ihe.gazelle.atna.Protocols']}</ui:define>
                    <rich:pickList id="protocolsInput" value="#{simulatorBean.protocols}" minListHeight="120px"
                                   maxListHeight="200px" required="true" disabled="#{simulatorBean.hasConnections()}">
                        <f:selectItems value="#{simulatorBean.getAvailableProtocols()}"/>
                    </rich:pickList>
                </s:decorate>

                <s:decorate template="/layout/form/_form_field_horizontal_3-9.xhtml">
                    <ui:param name="id" value="cipherSuitesInput"/>
                    <ui:define name="label">#{messages['net.ihe.gazelle.atna.CipherSuites']}</ui:define>
                    <rich:pickList id="cipherSuitesInput" value="#{simulatorBean.cipherSuites}" minListHeight="120px"
                                   maxListHeight="200px" required="true" disabled="#{simulatorBean.hasConnections()}">
                        <f:selectItems value="#{simulatorBean.getAvailableCipherSuites()}"/>
                    </rich:pickList>
                </s:decorate>

            </div>

        </ui:decorate>

        <ui:insert name="additionalParameters"/>

        <em class="pull-right">* #{messages['net.ihe.gazelle.atna.Required']}</em>
        <a4j:commandButton value="#{messages['net.ihe.gazelle.atna.Save']}" styleClass="gzl-btn-blue"
                           action="#{simulatorBean.saveSimulator()}" render="createForm"/>

        <ui:insert name="additionalButtons"/>

        <h:outputLink value="#{simulatorBean.linkToSimulatorList()}" styleClass="gzl-btn">
            #{messages['net.ihe.gazelle.atna.BackToList']}
        </h:outputLink>

    </h:form>
</ui:composition>